Index: applications/editors/josm/plugins/buildings_tools/build.xml
===================================================================
--- applications/editors/josm/plugins/buildings_tools/build.xml	(revision 28492)
+++ applications/editors/josm/plugins/buildings_tools/build.xml	(revision 28529)
@@ -30,5 +30,5 @@
 <project name="buildings_tools" default="dist" basedir=".">
     <!-- enter the SVN commit message -->
-    <property name="commit.message" value="BuildingTools: shortcut changes - binary"/>
+    <property name="commit.message" value="BuildingTools: move &quot;use address nodes&quot; option to building size dialog and turn it off by default"/>
     <!-- enter the *lowest* JOSM version this plugin is currently compatible with -->
     <property name="plugin.main.version" value="5035"/>
Index: applications/editors/josm/plugins/buildings_tools/src/buildings_tools/AdvancedSettingsDialog.java
===================================================================
--- applications/editors/josm/plugins/buildings_tools/src/buildings_tools/AdvancedSettingsDialog.java	(revision 28492)
+++ applications/editors/josm/plugins/buildings_tools/src/buildings_tools/AdvancedSettingsDialog.java	(revision 28529)
@@ -17,5 +17,4 @@
     private final JCheckBox cBigMode = new JCheckBox(tr("Big buildings mode"));
     private final JCheckBox cSoftCur = new JCheckBox(tr("Rotate crosshair"));
-    private final JCheckBox cAddrNode = new JCheckBox(tr("Use address nodes under buildings"));
 
     public AdvancedSettingsDialog() {
@@ -31,9 +30,7 @@
         panel.add(cBigMode, GBC.eol().fill(GBC.HORIZONTAL));
         panel.add(cSoftCur, GBC.eol().fill(GBC.HORIZONTAL));
-        panel.add(cAddrNode, GBC.eol().fill(GBC.HORIZONTAL));
 
         cBigMode.setSelected(ToolSettings.isBBMode());
         cSoftCur.setSelected(ToolSettings.isSoftCursor());
-        cAddrNode.setSelected(ToolSettings.PROP_USE_ADDR_NODE.get());
 
         setupDialog();
@@ -46,5 +43,4 @@
         ToolSettings.setBBMode(cBigMode.isSelected());
         ToolSettings.setSoftCursor(cSoftCur.isSelected());
-        ToolSettings.PROP_USE_ADDR_NODE.put(cAddrNode.isSelected());
     }
 }
Index: applications/editors/josm/plugins/buildings_tools/src/buildings_tools/BuildingSizeDialog.java
===================================================================
--- applications/editors/josm/plugins/buildings_tools/src/buildings_tools/BuildingSizeDialog.java	(revision 28492)
+++ applications/editors/josm/plugins/buildings_tools/src/buildings_tools/BuildingSizeDialog.java	(revision 28529)
@@ -16,8 +16,9 @@
 @SuppressWarnings("serial")
 public class BuildingSizeDialog extends MyDialog {
-    private JFormattedTextField twidth = new JFormattedTextField(NumberFormat.getInstance());
-    private JFormattedTextField tlenstep = new JFormattedTextField(NumberFormat.getInstance());
-    private JCheckBox caddr = new JCheckBox(tr("Use Address dialog"));
-    private JCheckBox cAutoSelect = new JCheckBox(tr("Auto-select building"));
+    private final JFormattedTextField twidth = new JFormattedTextField(NumberFormat.getInstance());
+    private final JFormattedTextField tlenstep = new JFormattedTextField(NumberFormat.getInstance());
+    private final JCheckBox caddr = new JCheckBox(tr("Use Address dialog"));
+    private final JCheckBox cAutoSelect = new JCheckBox(tr("Auto-select building"));
+    private final JCheckBox cAddrNode = new JCheckBox(tr("Use address nodes under buildings"));
 
     public BuildingSizeDialog() {
@@ -28,4 +29,5 @@
         panel.add(caddr, GBC.eol().fill(GBC.HORIZONTAL));
         panel.add(cAutoSelect, GBC.eol().fill(GBC.HORIZONTAL));
+        panel.add(cAddrNode, GBC.eol().fill(GBC.HORIZONTAL));
 
         twidth.setValue(ToolSettings.getWidth());
@@ -33,4 +35,5 @@
         caddr.setSelected(ToolSettings.isUsingAddr());
         cAutoSelect.setSelected(ToolSettings.isAutoSelect());
+        cAddrNode.setSelected(ToolSettings.PROP_USE_ADDR_NODE.get());
 
         JButton bAdv = new JButton(tr("Advanced..."));
@@ -74,4 +77,5 @@
         ToolSettings.setAddrDialog(useAddr());
         ToolSettings.setAutoSelect(cAutoSelect.isSelected());
+        ToolSettings.PROP_USE_ADDR_NODE.put(cAddrNode.isSelected());
     }
 }
Index: applications/editors/josm/plugins/buildings_tools/src/buildings_tools/ToolSettings.java
===================================================================
--- applications/editors/josm/plugins/buildings_tools/src/buildings_tools/ToolSettings.java	(revision 28492)
+++ applications/editors/josm/plugins/buildings_tools/src/buildings_tools/ToolSettings.java	(revision 28529)
@@ -14,5 +14,5 @@
 
 public class ToolSettings {
-    public static BooleanProperty PROP_USE_ADDR_NODE = new BooleanProperty("buildings_tools.addrNode", true);
+    public static BooleanProperty PROP_USE_ADDR_NODE = new BooleanProperty("buildings_tools.addrNode", false);
     private static double width = 0;
     private static double lenstep = 0;