Index: applications/editors/josm/plugins/measurement/build.xml
===================================================================
--- applications/editors/josm/plugins/measurement/build.xml	(revision 28807)
+++ applications/editors/josm/plugins/measurement/build.xml	(revision 28898)
@@ -27,10 +27,10 @@
 <project name="measurement" default="dist" basedir=".">
     <property name="commit.message" value="recompile dure to core change"/>
-    <property name="plugin.main.version" value="4980"/>
+    <property name="plugin.main.version" value="5560"/>
     <property name="josm" location="../../core/dist/josm-custom.jar"/>
     <property name="plugin.dist.dir" value="../../dist"/>
     <property name="plugin.build.dir" value="build"/>
     <property name="plugin.jar" value="${plugin.dist.dir}/${ant.project.name}.jar"/>
-    <property name="ant.build.javac.target" value="1.5"/>
+    <property name="ant.build.javac.target" value="1.6"/>
     <target name="init">
         <mkdir dir="${plugin.build.dir}"/>
Index: applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementDialog.java
===================================================================
--- applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementDialog.java	(revision 28807)
+++ applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementDialog.java	(revision 28898)
@@ -1,5 +1,4 @@
 package org.openstreetmap.josm.plugins.measurement;
 
-import static org.openstreetmap.josm.tools.I18n.marktr;
 import static org.openstreetmap.josm.tools.I18n.tr;
 
@@ -21,4 +20,5 @@
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.data.osm.Way;
+import org.openstreetmap.josm.gui.NavigatableComponent;
 import org.openstreetmap.josm.gui.SideButton;
 import org.openstreetmap.josm.gui.dialogs.ToggleDialog;
@@ -87,15 +87,15 @@
         valuePanel.add(new JLabel(tr("Path Length")));
 
-        pathLengthLabel = new JLabel("0 m");
+        pathLengthLabel = new JLabel(NavigatableComponent.getDistText(0));
         valuePanel.add(pathLengthLabel);
 
         valuePanel.add(new JLabel(tr("Selection Length")));
 
-        selectLengthLabel = new JLabel("0 m");
+        selectLengthLabel = new JLabel(NavigatableComponent.getDistText(0));
         valuePanel.add(selectLengthLabel);
 
         valuePanel.add(new JLabel(tr("Selection Area")));
 
-        selectAreaLabel = new JLabel("0 m\u00b2");
+        selectAreaLabel = new JLabel(NavigatableComponent.getAreaText(0));
         valuePanel.add(selectAreaLabel);
 
@@ -159,7 +159,7 @@
             }
         }
-        selectLengthLabel.setText(new DecimalFormat("#0.00").format(length) + " m");
+        selectLengthLabel.setText(NavigatableComponent.getDistText(length));
         segAngleLabel.setText(new DecimalFormat("#0.0").format(segAngle) + " \u00b0");
-        selectAreaLabel.setText(new DecimalFormat("#0.00").format(area) + " m\u00b2");
+        selectAreaLabel.setText(NavigatableComponent.getAreaText(area));
 	}
 
Index: applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementLayer.java
===================================================================
--- applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementLayer.java	(revision 28807)
+++ applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementLayer.java	(revision 28898)
@@ -10,5 +10,4 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.MouseEvent;
-import java.text.DecimalFormat;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -35,4 +34,5 @@
 import org.openstreetmap.josm.data.osm.visitor.BoundingXYVisitor;
 import org.openstreetmap.josm.gui.MapView;
+import org.openstreetmap.josm.gui.NavigatableComponent;
 import org.openstreetmap.josm.gui.dialogs.LayerListDialog;
 import org.openstreetmap.josm.gui.dialogs.LayerListPopup;
@@ -139,8 +139,6 @@
             last = p;
         }
-        DecimalFormat nf = new DecimalFormat("#0.00");
-        DecimalFormat nf2 = new DecimalFormat("#0.0");
         if (MeasurementPlugin.measurementDialog != null) { 
-            MeasurementPlugin.measurementDialog.pathLengthLabel.setText(pathLength < 800?nf2.format(pathLength) + " m":nf.format(pathLength/1000) + " km");
+            MeasurementPlugin.measurementDialog.pathLengthLabel.setText(NavigatableComponent.getDistText(pathLength));
         }
     }