Index: applications/editors/josm/plugins/wikipedia/build.xml
===================================================================
--- applications/editors/josm/plugins/wikipedia/build.xml	(revision 28987)
+++ applications/editors/josm/plugins/wikipedia/build.xml	(revision 28991)
@@ -1,31 +1,3 @@
 <?xml version="1.0" encoding="utf-8"?>
-<!--
-** This is a template build file for a JOSM  plugin.
-**
-** Maintaining versions
-** ====================
-** see README.template
-**
-** Usage
-** =====
-** To build it run
-**
-**    > ant  dist
-**
-** To install the generated plugin locally (in you default plugin directory) run
-**
-**    > ant  install
-**
-** The generated plugin jar is not automatically available in JOSMs plugin configuration
-** dialog. You have to check it in first.
-**
-** Use the ant target 'publish' to check in the plugin and make it available to other
-** JOSM users:
-**    set the properties commit.message and plugin.main.version
-** and run
-**    > ant  publish
-**
-**
--->
 <project name="wikipedia" default="dist" basedir=".">
 
@@ -35,53 +7,12 @@
     <property name="plugin.main.version" value="5089"/>
 
-    <!--
-    **********************************************************
-    ** include targets that all plugins have in common
-    **********************************************************
-    -->
+    <property name="plugin.author" value="simon04"/>
+    <property name="plugin.class" value="org.wikipedia.WikipediaPlugin"/>
+    <property name="plugin.description" value="Simplifys linking OSM objects to Wikipedia articles"/>
+    <property name="plugin.icon" value="images/dialogs/wikipedia.png"/>
+    <property name="plugin.link" value="http://josm.openstreetmap.de/wiki/Help/Plugin/Wikipedia"/>
+
+    <!-- ** include targets that all plugins have in common ** -->
     <import file="../build-common.xml"/>
-  
-    <!--
-    **********************************************************
-    ** dist - creates the plugin jar
-    **********************************************************
-    -->
-    <target name="dist" depends="compile,revision">
-        <echo message="creating ${ant.project.name}.jar ... "/>
-        <copy todir="${plugin.build.dir}/resources">
-            <fileset dir="resources"/>
-        </copy>
-        <copy todir="${plugin.build.dir}/images">
-            <fileset dir="images"/>
-        </copy>
-        <copy todir="${plugin.build.dir}/data">
-            <fileset dir="data"/>
-        </copy>
-        <copy todir="${plugin.build.dir}">
-            <fileset dir=".">
-                <include name="README"/>
-                <include name="LICENSE"/>
-            </fileset>
-        </copy>
-        <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
-            <!--
-            ************************************************
-            ** configure these properties. Most of them will be copied to the plugins
-            ** manifest file. Property values will also show up in the list available
-            ** plugins: http://josm.openstreetmap.de/wiki/Plugins.
-            **
-            ************************************************
-            -->
-            <manifest>
-                <attribute name="Author" value="simon04"/>
-                <attribute name="Plugin-Class" value="org.wikipedia.WikipediaPlugin"/>
-                <attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
-                <attribute name="Plugin-Description" value="Simplifys linking OSM objects to Wikipedia articles"/>
-                <attribute name="Plugin-Icon" value="images/dialogs/wikipedia.png"/>
-                <attribute name="Plugin-Link" value="http://josm.openstreetmap.de/wiki/Help/Plugin/Wikipedia"/>
-                <attribute name="Plugin-Mainversion" value="${plugin.main.version}"/>
-                <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
-            </manifest>
-        </jar>
-    </target>
+
 </project>