Index: applications/editors/josm/plugins/wms-turbo-challenge2/build.xml
===================================================================
--- applications/editors/josm/plugins/wms-turbo-challenge2/build.xml	(revision 28807)
+++ applications/editors/josm/plugins/wms-turbo-challenge2/build.xml	(revision 29210)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8"?>
-<!--
-** To build it run
-**
-**    > ant  dist
-**
-** To install the generated plugin locally (in you default plugin directory) run
-**
-**    > ant  install
--->
 <project name="wms-turbo-challenge2" default="dist" basedir=".">
 
@@ -14,47 +5,14 @@
     <property name="commit.message" value="Commit message"/>
     <!-- enter the *lowest* JOSM version this plugin is currently compatible with -->
-    <property name="plugin.main.version" value="4549"/>
+    <property name="plugin.main.version" value="4670"/>
 
-    <!--
-    **********************************************************
-    ** include targets that all plugins have in common
-    **********************************************************
-    -->
+    <property name="plugin.author" value="Andrzej Zaborowski"/>
+    <property name="plugin.class"  value="wmsturbochallenge.WMSRacer"/>
+    <property name="plugin.description" value="Drive a race car from point A to point B over aerial imagery, leave cacti behind."/>
+    <property name="plugin.icon" value="images/wmsracer.png"/>
+    <property name="plugin.link" value="http://wiki.openstreetmap.org/wiki/JOSM/Plugins/WMS_Racer"/>
+        
+    <!-- ** include targets that all plugins have in common ** -->
     <import file="../build-common.xml"/>
-  
-    <!--
-    **********************************************************
-    ** dist - creates the plugin jar
-    **********************************************************
-    -->
-    <target name="dist" depends="compile,revision">
-        <echo message="creating ${plugin.jar.name} ... "/>
-        <copy todir="${plugin.build.dir}/resources">
-            <fileset dir="resources"/>
-        </copy>
-        <copy todir="${plugin.build.dir}/images">
-            <fileset dir="images"/>
-        </copy>
-        <copy todir="${plugin.build.dir}/data">
-            <fileset dir="data"/>
-        </copy>
-        <copy todir="${plugin.build.dir}">
-            <fileset dir=".">
-                <include name="README"/>
-                <include name="LICENSE"/>
-            </fileset>
-        </copy>
-        <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
-            <manifest>
-                <attribute name="Author" value="Andrzej Zaborowski"/>
-                <attribute name="Plugin-Class" value="wmsturbochallenge.WMSRacer"/>
-                <attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
-                <attribute name="Plugin-Description" value="Drive a race car from point A to point B over aerial imagery, leave cacti behind."/>
-                <attribute name="Plugin-Icon" value="images/wmsracer.png"/>
-                <attribute name="Plugin-Link" value="http://wiki.openstreetmap.org/wiki/JOSM/Plugins/WMS_Racer"/>
-                <attribute name="Plugin-Mainversion" value="${plugin.main.version}"/>
-                <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
-            </manifest>
-        </jar>
-    </target>
+
 </project>
Index: applications/editors/josm/plugins/wms-turbo-challenge2/src/wmsturbochallenge/FakeMapView.java
===================================================================
--- applications/editors/josm/plugins/wms-turbo-challenge2/src/wmsturbochallenge/FakeMapView.java	(revision 28807)
+++ applications/editors/josm/plugins/wms-turbo-challenge2/src/wmsturbochallenge/FakeMapView.java	(revision 29210)
@@ -37,5 +37,5 @@
 
     public fake_map_view(MapView parent, double scale) {
-        super(null); //TODO MapView constructor contains registering listeners and other code, that probably shouldn't be called in fake map view
+        super(null, null); //TODO MapView constructor contains registering listeners and other code, that probably shouldn't be called in fake map view
         this.parent = parent;
         this.scale = scale;